# This example requires the 'message_content' privileged intent to function.

import asyncio

import discord
import yt_dlp as youtube_dl

from discord.ext import commands
from kabot.utils.audio import *
from kabot.utils.texte import *



intents = discord.Intents.all()
intents.message_content = True

bot = commands.Bot(
    command_prefix=commands.when_mentioned_or("!"),
    description='''A ROULEEEEETTES !!
    HOULA... J'l'ai un peu trop gueulé ça, non ?
    A roulettes.''',
    intents=intents,
)


@bot.event
async def on_ready():
    print(f'Logged in as {bot.user} (ID: {bot.user.id})')
    print('------')


async def main():
    ## création de l'objet logger
    logger = logging.getLogger()
    ## definition du log level
    logger.setLevel(logging.INFO)

    parser = argparse.ArgumentParser()
    parser.add_argument(
            "-c",
            "--config",
            help="config file",
            default="config.ini"
            )
    args = parser.parse_args()
    config = configparser.ConfigParser()
    if not os.path.exists(args.config):
        logger.critical('config file not found')
        exit(1)
    config.read(args.config)

    log_file = config['DEFAULT']['logs']
    ## definition du fichier de log (chemin, level, etc ...)
    formatter = logging.Formatter('%(asctime)s :: %(levelname)s :: %(message)s')
    file_handler = RotatingFileHandler(log_file, 'a', 1000000, 1)
    file_handler.setLevel(logging.INFO)
    file_handler.setFormatter(formatter)
    logger.addHandler(file_handler)

    if "nickname" in config['DEFAULT']:
        nickname = config['DEFAULT']['nickname']
    else:
        nickname = None
    if "voice_channel" in config['DEFAULT']:
        voice_channel = config['DEFAULT']['voice_channel']
    else:
        voice_channel = None
    if "text_channel" in config['DEFAULT']:
        text_channel = config['DEFAULT']['text_channel']
    else:
        text_channel = None
    audio_path = config['DEFAULT']['audio_path']
    token = config['discord']['token']
    gl_url = config['gitlab']['url']
    gl_token = config['gitlab']['token']
    gif_token = config['giphy']['token']
    async with bot:
        await bot.add_cog(
                Audio(
                    bot,
                    voice_chan=voice_channel,
                    text_chan=text_channel,
                    audio_path=audio_path,
                    )
                )
        await bot.add_cog(
                Texte(
                    bot,
                    gif_token=gif_token,
                    gl_token=gl_token,
                    gl_url=gl_url,
                    text_chan=text_channel,
                    )
                )
        await bot.start(token)

def run():
    asyncio.run(main())

if __name__ == "__main__":
    run()
